///// Inductor.java /////
/**
 * Class that emulate a inductor conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;
import java.lang.*;
import java.io.*;

public class Inductor extends ElectricalElement implements Serializable, Cloneable{
	public Inductor clone(){
/*		try{*/
			return (Inductor) super.clone();
/*		}
		catch(CloneNotSupportedException e){
			return null;
		}*/
	}

	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double dir, inductance, voltage, current;
	private InductorView view;

	public Inductor(int tlx, int tly, int w){
		super(id++);
		inductance=voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		dir=0; // 0:Right, 1:Up, 2:Left, 3:Down
		view = new InductorView(this);
	}

	public double getCurrent(){
		return 0;
	/* I=1/C*integrate(VIdt). Not used. to be implemented as future project*/
	}

	public double getDirection(){
		return dir;
	}

	public double getVoltage(){
		return 0;
	/* V=C*dI/dt. Not used. to be implemented as future project*/
	}

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}

	public void setDirection(double d){
		dir=d;
	}
	
	public void setValue(double value){
		inductance=value;
	}
}
