///// MatrixElement.java /////
/**
 * Matrix Cell. Containts links to adjacent's cells. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;

import java.io.*;

public class MatrixElement implements Serializable {

	/**
	 * Adjacent cell's elements.
	 */
	private ElectricalElement up, down, left, right;
	
	/**
	 * This cell's element.
	 */
	private ElectricalElement myElement;

	/**
	 * Contructor MatrixElement. Initializes a empty cell.
	 */
	public MatrixElement(){
		up=down=left=right=myElement=null;
	}

	/**
	 * Retrieves the down element's cell .
	 * @return down
	 */
	public ElectricalElement getDowmElement(){
		return down;
	}

	/**
	 * Retrieves the left element's cell .
	 * @return left 
	 */
	public ElectricalElement getLeftElement(){
		return left;
	}

	/**
	 * Retrieves the element's cell.
	 * @return myElement
	 */
	public ElectricalElement getMyElement(){
		return myElement;
	}

	/**
	 * Retrieves the right element's cell .
	 * @return right 
	 */
	public ElectricalElement getRightElement(){
		return right;
	}

	/**
	 * Retrieves the up element's cell .
	 * @return up
	 */
	public ElectricalElement getUpElement(){
		return up;
	}

	public void paintView(Graphics2D g){
		if(myElement!=null)
			myElement.paintView(g);
	}

	public void resizeMyElement(int cx, int cy, int tlx, int tly, int w){
		if(myElement!=null)
			myElement.resize(tlx+cx*w,tly+cy*w,w);
	}

	/**
	 * Set the down element's cell .
	 * @param e electrical element 
	 */  
	public void setDowmElement(ElectricalElement e){
		down=e;
	}

	/**
	 * Set the left element's cell .
	 * @param e electrical element 
	 */  
	public void setLeftElement(ElectricalElement e){
		left=e;
	}

	/**
	 * Set the element's cell.
	 * @param e electrical element
	 */ 
	public void setMyElement(ElectricalElement e){
		myElement=e;
	}	
	
	/**
	 * Set the right element's cell .
	 * @param e electrical element 
	 */  
	public void setRightElement(ElectricalElement e){
		right=e;
	}

	/**
	 * Set the up element's cell .
	 * @param e electrical element 
	 */  
	public void setUpElement(ElectricalElement e){
		up=e;
	}

}