///// MatrixView.java /////
/**
 * Matrix View. Manage Drawer View. Extends from Panel.
 * @author Jesus Márquez Barrera
 */

import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;


public class MatrixView extends JPanel{

	private Matrix matrix;
  private MouseListener mListener;
	
	public MatrixView(Matrix m){
		matrix = m;
    mListener = new MouseListener(m);
    addMouseMotionListener(mListener);
    addMouseListener(mListener);
	}

	public void paintComponent(Graphics g){
   	Graphics2D g2 = (Graphics2D)g;
   	super.paintComponent(g);

   	if(matrix.isGridOn())
   		matrix.getGrid().draw(g2);

   	MatrixElement[][] cells = matrix.getShownMatrix();
   	for(int i=0;i<matrix.getYCellShown();i++){
   		for(int j=0;j<matrix.getXCellShown();j++){
   			cells[i][j].paintView(g2);
   		}
   	}
  }

  public void removeMouseListener(){
      removeMouseMotionListener(mListener);
      removeMouseListener(mListener);            
  }
  public void addMouseListener(){
      addMouseMotionListener(mListener);
      addMouseListener(mListener);      
  }

  public Matrix getMatrix(){
    return matrix;
  }
}