///// VoltageSource.java /////
/**
 * Class that emulate a voltage's source conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;

import java.io.*;

public class VoltageSource extends ElectricalElement implements Serializable, Cloneable{
	public VoltageSource clone(){
/*		try{*/
			return (VoltageSource) super.clone();
		/*}
		catch(CloneNotSupportedException e){
			return null;
		}*/
	}

	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double dir, voltage, current;
	private VoltageSourceView view;

	public VoltageSource(int tlx, int tly, int w){
		super(id++);
		voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		dir=0; // 0:Right, 1:Up, 2:Left, 3:Down
		view = new VoltageSourceView(this);
	}

	public double getCurrent(){
		return 0;
	/*I=0. Not used. to be implemented as future project*/
	}

	public double getDirection(){
		return dir;
	}


	public double getVoltage(){
		return 0;
	/* return voltage; Not used. to be implemented as future project*/
	}	

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}

	public void setDirection(double d){
		dir=d;
	}

	public void setValue(double value){
		voltage=value;
	}

}