///// Wire.java /////
/**
 * Class that emulate a wire conduct. Implements Serializable
 * @author Jesus Márquez Barrera
 */

import java.awt.*;
import java.lang.*;
import java.io.*;

public class Wire extends ElectricalElement implements Serializable, Cloneable{
	public Wire clone(){
		/*try{*/
			return (Wire) super.clone();
		/*}
		catch(CloneNotSupportedException e){
			return null;
		}*/
	}

	private static int id=0;
	private int topLeftX, topLeftY, width;
	private double dir, resistance, voltage, current;
	private WireView view;

	public Wire(int tlx, int tly, int w){
		super(id++);
		resistance=voltage=current=0;
		topLeftX=tlx;
		topLeftY=tly;
		width=w;
		dir=0; // 0:Right, 1:Up, 2:Left, 3:Down
		view = new WireView(this);
	}

	public double getCurrent(){
		return 0;
	/* I=0, Ideal wire. Not used. to be implemented as future project*/
	}

	public double getDirection(){
		return dir;
	}


	public double getVoltage(){
		return 0;
	/* V=0, Ideal wire. Not used. to be implemented as future project*/
	}

	public int topLeftX(){
		return topLeftX;
	}

	public int topLeftY(){
		return topLeftY;
	}

	public int width(){
		return width;
	}

	public void paintView(Graphics2D g){
		view.draw(g);
	}
	
	public void resize(int tlx, int tly, int w){
		topLeftX=tlx;
		topLeftY=tly;
		width=w;		
	}

	public void setDirection(double d){
		dir=d;
	}
	
	public void setValue(double value){
		resistance=0;  //wire's resistance always zero.
	}

}